int distReadL(void)
{
  digitalWrite (9,HIGH);
  delay( 2 );
  int DistL = (1024-analogRead(2));
  digitalWrite (9,LOW);
  return DistL;
}

int distReadR(void)
{
  digitalWrite (10,HIGH);
  delay( 2 );
  int DistR = (1024-analogRead(3));
  digitalWrite (10,LOW);
  return DistR;
}

int _ABVAR_1_a;
void BBR_Tone(int freq, int duration, float wait)
{
  tone(7, freq, duration);
  float x = (1+(wait/100));
  int procent = (duration*x);
  delay(procent);
  noTone(7);
  //extra code om de timer, gebruikt voor tone terug vrij te geven voor PWM
#define sbi(sfr,b) (_SFR_BYTE(sfr) |= _BV(b))
  TCCR3A = 0;
  TCCR3B = 0;
  sbi(TCCR3B, CS31);
  sbi(TCCR3B, CS30);
  sbi(TCCR3A, WGM30);
  analogWrite(5, 1);
  analogWrite(5, 0);
}

int _ABVAR_2_a;
void BBR_leds(bool a,bool b,bool c,bool d)
{
  if (a) digitalWrite(11,HIGH);
  else digitalWrite(11,LOW);
  if (b) digitalWrite(13,HIGH);
  else digitalWrite(13,LOW);
  if (c) digitalWrite(30,HIGH);
  else digitalWrite(30,LOW);
  if (d) digitalWrite(17,HIGH);
  else digitalWrite(17,LOW);
}
void BBR_motors(int L, int R)
{
  if (L<0)
  {
    digitalWrite(14, HIGH);
    int REVL = (255+L); //L is neg zo this is actually 255-L 
    analogWrite(6, REVL);
  }
  else
  {
    digitalWrite(14, LOW);
    analogWrite(6, L);
  }

  if (R<0)
  {
    digitalWrite(16, HIGH);
    int REVR = (255+R); //R is neg so this is actually 255-R 
    analogWrite(5, REVR);
  }
  else
  {
    digitalWrite(16, LOW);
    analogWrite(5, R);
  }
}

void TEST_ACTUATOR();
void TEST_SENSOREN();

void setup()
{
  pinMode( 22 , INPUT);
  pinMode( 12 , INPUT);
  pinMode( 4 , INPUT);
  pinMode( 8 , INPUT);
  pinMode( 11 , OUTPUT);
  pinMode( 13 , OUTPUT);
  pinMode( 14 , OUTPUT);
  pinMode( 5 , OUTPUT);
  pinMode( 16 , OUTPUT);
  pinMode( 17 , OUTPUT);
  pinMode( 6 , OUTPUT);
  pinMode( 7 , OUTPUT);
  pinMode( 9 , OUTPUT);
  pinMode( 30 , OUTPUT);
  pinMode( 10 , OUTPUT);
  Serial.begin(9600);
  digitalWrite(9, LOW);

  digitalWrite(10, LOW);

  digitalWrite(7, LOW);

  digitalWrite(11, LOW);
  digitalWrite(13, LOW);
  digitalWrite(30, LOW);
  digitalWrite(17, LOW);
  digitalWrite(5, LOW);
  digitalWrite(6, LOW);
  digitalWrite(14, LOW);
  digitalWrite(16, LOW);
}

void loop()
{
  TEST_ACTUATOR();
  while ( true )
  {
    TEST_SENSOREN();
  }

}

void TEST_SENSOREN()
{
  Serial.print("LICHT_L:");
  Serial.print("	");
  Serial.print(String(analogRead(A0)));
  Serial.print("\t");
  Serial.print("	");
  Serial.print("LICHT_R:");
  Serial.print("	");
  Serial.print(String(analogRead(A1)));
  Serial.print("\t");
  Serial.print("	");
  Serial.print("AFST_L");
  Serial.print("	");
  Serial.print(String(distReadL()));
  Serial.print("\t");
  Serial.print("	");
  Serial.print("AFST_R");
  Serial.print("	");
  Serial.print(String(distReadR()));
  Serial.print("\t");
  Serial.print("	");
  Serial.print("KNOP_L");
  Serial.print("	");
  Serial.print(String(digitalRead(8)));
  Serial.print("__KNOP_R");
  Serial.print("	");
  Serial.print(String(digitalRead(22)));
  Serial.print("\t");
  Serial.print("	");
  Serial.print("LIJN_L");
  Serial.print("	");
  Serial.print(String(digitalRead(4)));
  Serial.print("__LIJN_R");
  Serial.print("	");
  Serial.print(String(digitalRead(12)));
  Serial.println();
  delay( 300 );
}

void TEST_ACTUATOR()
{
  for (_ABVAR_1_a=1; _ABVAR_1_a<= ( 5 ); ++_ABVAR_1_a )
  {
    BBR_Tone(440,400,30);
    BBR_Tone(880,400,30);
  }
  for (_ABVAR_2_a=1; _ABVAR_2_a<= ( 5 ); ++_ABVAR_2_a )
  {
    BBR_leds(HIGH,HIGH,HIGH,HIGH);
    BBR_motors(255,255);
    delay( 1000 );
    BBR_leds(LOW,LOW,LOW,LOW);
    BBR_motors(-255,-255);
    delay( 1000 );
  }
  BBR_motors(0,0);
}


